#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <functional>
#include <windows.h>

#define PORT 2902
#define BUFSIZE 1024

// Funktor pro odesilani textu.
struct SendText : public std::unary_function<int, void>
{
  std::string Text;
  void operator() (int socket)
  {
    send(socket, Text.c_str(), Text.size(), 0);
  }
};

int main(int argc, char *argv[])
{
  timeval tv;
  SOCKET mainSocket;
  std::vector<SOCKET> sockets;
  fd_set socketSet;
  sockaddr_in clientInfo, sockName;
  WORD wVersionRequested = MAKEWORD(1,1);
  WSADATA data;
  
  if (WSAStartup(wVersionRequested, &data) != 0)
  {
    std::cerr << "Nepodarilo se inicializovat sokety" << std::endl;
    // Podle vseho, zde se WSACleanup volat nemusi.
    return -1;
  }
  if ((mainSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET)
  {
     std::cerr << "Nelze vytvorit soket" << std::endl;
     return -1;
  }
  sockName.sin_family = AF_INET;
  sockName.sin_port = htons(PORT); 
  sockName.sin_addr.s_addr = INADDR_ANY;
  if (bind(mainSocket, (sockaddr *)&sockName, sizeof(sockName)) == -1)
  {
     std::cerr << "Problem s pojmenovanim soketu." << std::endl;
     return -1;
  }
  if (listen(mainSocket, 10) == -1)
  {
    std::cerr << "Problem s vytvorenim fronty" << std::endl;
    return -1;
  }
  // Vyprazdnim mnozinu
  FD_ZERO(&socketSet);
  // Nastavim soket do mnoziny - mnozina ma zatim jen jeden prvek.
  FD_SET(mainSocket, &socketSet);
  // Nastavim cekaci dobu 3 minuty
  tv.tv_sec = 180;
  tv.tv_usec = 0;
  // Budu opakovat, dokud nedojde k chybe (vraci -1), nebo pocet zmen
  // bude roven 0 (nic se nestalo, vyprsel casovy limit).
  while (select(0, &socketSet, NULL, NULL, &tv) > 0)
  {
    // Je nejaka zmena na "hlavnim" soketu?
    if (FD_ISSET(mainSocket, &socketSet))
    {
      int addrlen = sizeof(clientInfo);
      // Prijimam nove spojeni
      SOCKET client = accept(mainSocket, (sockaddr*)&clientInfo, &addrlen);
      sockets.push_back(client);
    }
    // Projdu vsechna spojeni a zkontroluji, jestli na nich nedoslo k zmene
    for(std::vector<SOCKET>::iterator i = sockets.begin(); i != sockets.end(); i++)
    {
      if (FD_ISSET(*i, &socketSet))
      {
            char buffer[BUFSIZE];
            int lenght;
            if ((lenght = recv(*i, buffer, BUFSIZE - 1, 0)) <= 0)
            {
  	             // Prijato 0 bytu - druha strana uzavrela spojeni
  	             closesocket(*i);
  	             sockets.erase(i);
  	             // Ukoncim cyklus. Neni dobre pokracovat v prochazeni kontejneru, kdyz jsem vymazal prvek.
  	             break;
            }
            else
            {
                 // Vytvorim funkcni objekt.
                 SendText s;
                 buffer[lenght] = 0;
                 // Nastavim text pro odeslani. 
                 s.Text = buffer;
                 // Pro vsechny prvky v kontejneru odeslu text. 
                 for_each(sockets.begin(), sockets.end(), s);
            }
      } 
    }
    // Znovu vyplnim prvky mnoziny
    // Vyprazdnim mnozinu
    FD_ZERO(&socketSet);
    // Nastavim hlavni soket
    FD_SET(mainSocket, &socketSet);
    // Nastavim vsechny ostatni sokety.
    for(std::vector<SOCKET>::iterator i = sockets.begin(); i != sockets.end(); i++)
    {
      FD_SET(*i, &socketSet);
    }
    // Nastavim cekaci dobu 3 minuty
    tv.tv_sec = 180;
    tv.tv_usec = 0;
  }
  // Zavru hlavni soket
  closesocket(mainSocket);
  // Vsechny ostatni sokety take uzavru.
  for_each(sockets.begin(), sockets.end(), closesocket);
  WSACleanup();
}
